﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	
	Public titleback As B4XView
	Public title As Label
	Public butclose As B4XView
	Public windowframe As Pane
	Public butmax As B4XView
	Public butmin As B4XView
	
	Private befsizewidth As Double
	Private befsizeheight As Double
	Private befleft As Double
	Private beftop As Double
	
	Public ismin As Boolean = False
	Public ismax As Boolean = False
	Public ismodal As Boolean = False
	Public closed As Boolean=False

	Public thewindow As B4XView
	Public myid As String
	
	Private IntoResizeThings As Boolean=False
	Private fx As JFX
	Private thebase As Pane
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	mBase.LoadLayout("Window1")
    Tag = mBase.Tag
    mBase.Tag = Me 
	thewindow=mBase.parent
End Sub



Private Sub Base_Resize (Width As Double, Height As Double)
	If ismin=False And IntoResizeThings=False Then
		If Width<=150 Then thewindow.Width=150
		If Height<=100 Then thewindow.Height=100
	End If
End Sub




public Sub HasResize
	ResizeHandler.AddListeners(thewindow)
	Dim layoutpane As Pane = thewindow.GetView(0).GETVIEW(0).GetView(4)
	layoutpane.MouseCursor=fx.Cursors.DEFAULT
	butclose.As(Pane).MouseCursor=fx.Cursors.DEFAULT
	butmin.As(Pane).MouseCursor=fx.Cursors.DEFAULT
	butmax.As(Pane).MouseCursor=fx.Cursors.DEFAULT
End Sub

public Sub SetVisible(t As Boolean)
	thewindow.Visible=t
End Sub

Public Sub SetMinimize
	setmin
End Sub

Public Sub SetMaximize
	setmax
End Sub

public Sub SetModal(t As Boolean)
	If t=True Then
		For Each p As B4XView In mBase.parent.parent.GetAllViewsRecursive
			If p.Tag="background" Then
				'At MainPage.bjl is good to have a pane full sized and all anchors... in full
				p.BringToFront
				p.SetAlphaAnimated(0,0.5)
				p.Visible=True
				thewindow.BringToFront
				ismodal=True
				Return
			End If
		Next 
	Else
		For Each p As B4XView In mBase.parent.parent.GetAllViewsRecursive
			If p.Tag="background" Then
				p.SendToBack
				p.Visible=False
				thewindow.BringToFront
				ismodal=False
				Return
			End If
		Next
	End If
End Sub


Sub setmin
	IntoResizeThings=True
	If ismin=True Then Return
	befleft=thewindow.Left
	beftop=thewindow.top
	befsizeheight=thewindow.Height
	befsizewidth=thewindow.Width
	thewindow.Height=titleback.Height+9
	thewindow.Width=200
	thewindow.Top=thewindow.parent.Height-thewindow.Height
	ismin=True
	sortatline
	Sleep(1000)
	IntoResizeThings=False
End Sub

Private Sub butclose_MouseClicked (EventData As MouseEvent)
	Close
	
End Sub

Private Sub titleback_MouseClicked (EventData As MouseEvent)
	thewindow.BringToFront
	If EventData.ClickCount=2 Then
			setmax
	End If
End Sub

Private Sub butmin_MouseClicked (EventData As MouseEvent)
	
	setmin
	
End Sub

Private Sub butmax_MouseClicked (EventData As MouseEvent)

	setmax
	
End Sub

Sub setmax
	thewindow.BringToFront
	
	If ismin=True Or ismax=True Then
		IntoResizeThings=True
		ismin=False
		ismax=False
		thewindow.Height=befsizeheight
		thewindow.Width=befsizewidth
		thewindow.Top=beftop
		thewindow.Left=befleft
		sortatline
		Sleep(1000)
		IntoResizeThings=False
		Return
	End If
	
	If ismin=False Or ismax=False Then
		
		IntoResizeThings=True
		
		If ismin=False Or ismax=False Then
			befleft=thewindow.Left
			beftop=thewindow.top
			befsizeheight=thewindow.Height
			befsizewidth=thewindow.Width
		End If

		ismin=False
		ismax=True
		thewindow.Height=mBase.Parent.Parent.Height-(titleback.Height+9)
		thewindow.Width=mBase.Parent.Parent.Width
		thewindow.Top=0
		thewindow.Left=0
		sortatline
		Sleep(1000)
		IntoResizeThings=False
		Return
	End If
	
		
End Sub

public Sub sortatline
	Dim sleft As Double=0

	For Each n As B4XView In mBase.parent.parent.GetAllViewsRecursive
		If n.Tag.As(String).trim="isWindow" Then
			Dim nwindow As childwindow=n.getview(0).tag
			If nwindow.ismin=True And nwindow.closed=False Then
				n.left=sleft
				sleft=sleft+1+n.Width
			End If
		End If
	Next

End Sub


Private Sub thebase_MouseClicked (EventData As MouseEvent)
	thewindow.BringToFront
End Sub

public Sub Close
	If ismodal=True Then
		SetModal(False)
	End If
	closed=True
	thewindow.Visible=False
	sortatline
End Sub

public Sub HaveControls(havecontrol As String)
	'MinMaxClose
	Select Case havecontrol
		Case "MinMaxClose"
			butclose.SetAlphaAnimated(0,1)
			butmin.SetAlphaAnimated(0,1)
			butmax.SetAlphaAnimated(0,1)
			butclose.Enabled=True
			butmax.Enabled=True
			butmin.Enabled=True
		Case "MaxClose"
			butclose.SetAlphaAnimated(0,1)
			butclose.Enabled=True
			butmin.SetAlphaAnimated(0,0.5)
			butmin.Enabled=False
			butmax.SetAlphaAnimated(0,1)
			butmax.Enabled=True
		Case "MinClose"
			butclose.SetAlphaAnimated(0,1)
			butmin.SetAlphaAnimated(0,1)
			butmax.SetAlphaAnimated(0,0.5)
			butclose.Enabled=True
			butmax.Enabled=False
			butmin.Enabled=True
		Case "Close"
			butclose.SetAlphaAnimated(0,1)
			butmin.SetAlphaAnimated(0,0.5)
			butmax.SetAlphaAnimated(0,0.5)
			butclose.Enabled=True
			butmax.Enabled=False
			butmin.Enabled=False

		Case ""
			butclose.SetAlphaAnimated(0,0.5)
			butmin.SetAlphaAnimated(0,0.5)
			butmax.SetAlphaAnimated(0,0.5)
			butclose.Enabled=False
			butmax.Enabled=False
			butmin.Enabled=False

	End Select
	
End Sub